package info.aspirecn.iov.sjjh.supplier10000034.service;

import java.io.IOException;
import java.net.SocketTimeoutException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Pattern;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang3.ArrayUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSON;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.exc.UnrecognizedPropertyException;

import info.aspirecn.iov.sjjh.commons.lang.ChannelTypeHandleResponseObject;
import info.aspirecn.iov.sjjh.commons.lang.Constant;
import info.aspirecn.iov.sjjh.commons.lang.PatternTools;
import info.aspirecn.iov.sjjh.supplier10000034.SjjhConstants;
import info.aspirecn.iov.sjjh.supplier10000034.gjwl.Response;
import info.aspirecn.iov.sjjh.supplier10000034.gjwl.util.PostUtil;
import info.aspirecn.iov.sjjh.supplier10000034.vo.CheckVehicleExistResponseObject;
import info.aspirecn.iov.sjjh.supplier10000034.vo.EnterpriseJsonResolveObject;
import info.aspirecn.iov.sjjh.supplier10000034.vo.EnterpriseResponseObject;
import info.aspirecn.iov.sjjh.supplier10000034.vo.EnterpriseSjxyRequestObject;
import info.aspirecn.iov.sjjh.supplier10000034.vo.OverloadCheckJsonResolveObject;
import info.aspirecn.iov.sjjh.supplier10000034.vo.PersonJsonResolveObject;
import info.aspirecn.iov.sjjh.supplier10000034.vo.PersonResponseObject;
import info.aspirecn.iov.sjjh.supplier10000034.vo.PersonSjxyRequestObject;
import info.aspirecn.iov.sjjh.supplier10000034.vo.ResultBody;
import info.aspirecn.iov.sjjh.supplier10000034.vo.VehicleExistSjxyRequestObject;
import info.aspirecn.iov.sjjh.supplier10000034.vo.VehicleInToNetResolveObject;
import info.aspirecn.iov.sjjh.supplier10000034.vo.VehiclePermitDetailsResponseObject;
import info.aspirecn.iov.sjjh.supplier10000034.vo.VehiclePermitJsonResolveObject;
import info.aspirecn.iov.sjjh.supplier10000034.vo.VehiclePermitSjxyRequstObject;
import info.aspirecn.rdc.aspirecloud.node.except.utils.ErrorUtils;
import lombok.extern.slf4j.Slf4j;


/**
 * 
 * @author bzh
 *
 */
@Slf4j
@Service
public class Supplier10000034ServiceImpl implements Supplier10000034Service {	
	

	@Value("${custom.appKey}")
	private String appKey;
	@Value("${custom.appSecret}")
	private String appSecret;
	@Value("${custom.enterpriseUrl}")
	private String enterpriseUrl;
	@Value("${custom.personUrl}")
	private String personUrl;
	@Value("${custom.urlVehiclePermit}")
	private String urlVehiclePermit;
	@Value("${custom.urlCheckVehicleExist}")
	private String urlCheckVehicleExist;
	@Value("${custom.sleepTime}")
	private String sleepTime;
	@Autowired
	private ObjectMapper objectMapper;

	/**车版颜色： 1：蓝色  2：黄色  默认黄色*/
	private static final String[] CAR_COLOR_ARRAY = {"1","2"};
	/**
     *查询运政企业信息
	 */	
   @Override
	public ChannelTypeHandleResponseObject queryEnterprise(HttpServletRequest request, String customBody,
			int outTime) {
		
		ChannelTypeHandleResponseObject ret = new ChannelTypeHandleResponseObject();
		ret.setIsCharge(Constant.INTERFACE_QUERY_NO_FEE);
		String upstreamCode = "" + Constant.LOG_UPSTREAM_DEFAULT_RESPONSE_CODE;
		request.setAttribute(Constant.LOG_UPSTREAM_RESPONSE_CODE, upstreamCode);
		try {
			if (outTime <= SjjhConstants.PARA_ZERO) {
				outTime = Constant.HTTPCLIENT_CONNECTTIMEOUT;
			}
			log.info("queryEnterprise---customBody={},outTime={}",customBody,outTime);
			ObjectMapper objectMapper = new ObjectMapper();
			EnterpriseJsonResolveObject jsonResolveObject=objectMapper.readValue(customBody,
					EnterpriseJsonResolveObject.class);
			log.info("supplier10000034.queryEnterprise---requestObject={}", jsonResolveObject);
			List<String> list=new ArrayList<String>();
			if (StringUtils.isBlank(jsonResolveObject.getCarrier())&&"".equals(jsonResolveObject.getCarrier())&&!isChinese(jsonResolveObject.getCarrier())) {
				list.add("carrier");
			}
			if (StringUtils.isBlank(jsonResolveObject.getProvinceCode())&&"".equals(jsonResolveObject.getProvinceCode())) {
				list.add("provinceCode");
			}
			if (StringUtils.isBlank(jsonResolveObject.getPermitNumber())&&"".equals(jsonResolveObject.getPermitNumber())) {
				list.add("permitNumber");
			}
			if (StringUtils.isBlank(jsonResolveObject.getPeriodStartDate())&&"".equals(jsonResolveObject.getPeriodStartDate())) {
				list.add("periodStartDate");
			}
			if (StringUtils.isBlank(jsonResolveObject.getPeriodEndDate())&&"".equals(jsonResolveObject.getPeriodEndDate())) {
				list.add("periodEndDate");
			}
			if (list.size() > 0) {
				ret.setCode(Constant.SUCCESS);
				ResultBody resultBody = new ResultBody();
				resultBody.setCode(3);
				resultBody.setResultList(list);
				ret.setResultBody(resultBody);
				ret.setResultCode(Constant.UN_MATCH_CODE);
				return ret;
			}
		    Map<String, Object> map = new HashMap<>();
		    map.put("enterpriseName", jsonResolveObject.getCarrier());
		    map.put("provinceCode", jsonResolveObject.getProvinceCode().substring(0, 2)+"0000");
		    String  body= JSON.toJSONString(map);
	 	    Response responseContext = PostUtil.postString(enterpriseUrl, body, appKey, appSecret,outTime);
		    log.info("supplier10000034.queryEnterprise接口responseContext={}", responseContext.getBody());
            EnterpriseResponseObject responseObject = objectMapper.readValue(
					responseContext.getBody(), EnterpriseResponseObject.class);
            log.info("supplier10000034.queryEnterprise接口responseObject={}", responseObject);
	      	if (responseObject != null) {
				ret.setCode(Constant.SUCCESS);
 				if (SjjhConstants.RESULT_CODE_0.equals(responseObject.getResultCode())) {
					// 查询成功
					ret.setIsCharge(Constant.INTERFACE_QUERY_FEE);
					if(responseObject.getData().getEnterpriseName() == null || "".equals(responseObject.getData().getEnterpriseName())){
						list.add("carrier");
					}
					if(responseObject.getData().getPermitNumber() == null || "".equals(responseObject.getData().getPermitNumber())){
						list.add("permitNumber");
					}
					if(responseObject.getData().getPeriodStartDate() == null || "".equals(responseObject.getData().getPeriodStartDate())){
						list.add("periodStartDate");
					}
					if(responseObject.getData().getPeriodEndDate() == null || "".equals(responseObject.getData().getPeriodEndDate())){
						list.add("periodEndDate");
					}
					if(list.size() > 0){
						//数据源为空响应
						ret.setResultCode(Constant.UN_MATCH_CODE);
						ResultBody resultBody = new ResultBody();
						resultBody.setCode(1);
						resultBody.setResultList(list);
						ret.setResultBody(resultBody);
					}else{
						SimpleDateFormat sdf=new SimpleDateFormat("yyyyMMdd");
						if (!jsonResolveObject.getCarrier().equals(responseObject.getData().getEnterpriseName())) {
							list.add("carrier"); 
						}
						if (!jsonResolveObject.getPermitNumber().equals(responseObject.getData().getPermitNumber())) {
							list.add("permitNumber"); 
						}
						if (!sdf.parse(jsonResolveObject.getPeriodStartDate()).equals(sdf.parse(responseObject.getData().getPeriodStartDate()))) {
							list.add("periodStartDate");
						}
						if (!sdf.parse(jsonResolveObject.getPeriodEndDate()).equals(sdf.parse(responseObject.getData().getPeriodEndDate()))) {
							list.add("periodEndDate");
						}
						if(list.size() > 0){
							//数据不一致响应
							ret.setResultCode(Constant.UN_MATCH_CODE);
							ResultBody resultBody = new ResultBody();
							resultBody.setCode(2);
							resultBody.setResultList(list);
							ret.setResultBody(resultBody);
						}else {
							//数据一致响应
							ret.setResultCode(Constant.MATCH_CODE);
							ret.setResultBody("一致");
						}
					}
				}else {
					// 其他错误
					ret.setCode(Constant.SUCCESS);
					ResultBody resultBody = new ResultBody();
					resultBody.setCode(3);
					list.add("carrier"); 
					list.add("permitNumber"); 
					list.add("periodStartDate");
					list.add("periodEndDate");
					resultBody.setResultList(list);
					ret.setResultBody(resultBody);
					ret.setResultCode(Constant.UN_MATCH_CODE);
				}
	      	}
	        	
		} catch (SocketTimeoutException ste) {
			 ErrorUtils.captureException(ste);
	            log.info("supplier10000034.queryEnterprise接口SocketTimeoutException={}", ste);
	            ret.setCode(Constant.REQUEST_TIMEOUT);
		} catch (UnrecognizedPropertyException upe) {
			log.info("supplier10000034.queryEnterprise接口-UnrecognizedPropertyException：{}", upe);
			ErrorUtils.captureException(upe);
			ret.setCode(Constant.SUCCESS);
			// 其他错误
			List<String> list=new ArrayList<String>();
			ResultBody resultBody = new ResultBody();
			resultBody.setCode(3);
			list.add("carrier"); 
			list.add("permitNumber"); 
			list.add("periodStartDate");
			list.add("periodEndDate");
			resultBody.setResultList(list);
			ret.setResultBody(resultBody);
			ret.setResultCode(Constant.UN_MATCH_CODE);
			return ret;
		} catch (Exception e) {
			log.info("supplier10000034.queryEnterprise接口-Exception：{}", e);
			ErrorUtils.captureException(e);
			ret.setCode(Constant.FAIL);
		}
		return ret;
	}

	/**
     *查询运政人员信息
	 */	
	@Override
	public ChannelTypeHandleResponseObject queryPerson(HttpServletRequest request, String customBody,
			int outTime) {
		
		ChannelTypeHandleResponseObject ret = new ChannelTypeHandleResponseObject();
		ret.setIsCharge(Constant.INTERFACE_QUERY_NO_FEE);
		String upstreamCode = "" + Constant.LOG_UPSTREAM_DEFAULT_RESPONSE_CODE;
		request.setAttribute(Constant.LOG_UPSTREAM_RESPONSE_CODE, upstreamCode);
		try {
			if (outTime <= SjjhConstants.PARA_ZERO) {
				outTime = Constant.HTTPCLIENT_CONNECTTIMEOUT;
			}
			log.info("queryPerson---customBody={},outTime={}",customBody,outTime);
			ObjectMapper objectMapper = new ObjectMapper();
			PersonJsonResolveObject jsonResolveObject=objectMapper.readValue(customBody,
					PersonJsonResolveObject.class);
			log.info("supplier10000034.queryPerson---requestObject={}", jsonResolveObject);
			List<String> list=new ArrayList<String>();
			if (StringUtils.isBlank(jsonResolveObject.getNameOfPerson())&&"".equals(jsonResolveObject.getNameOfPerson())) {
				list.add("nameOfPerson");
			}
			if (StringUtils.isBlank(jsonResolveObject.getProvinceCode())&&"".equals(jsonResolveObject.getProvinceCode())&&!isNumber(jsonResolveObject.getProvinceCode())) {
				list.add("provinceCode");
			}
			if (StringUtils.isBlank(jsonResolveObject.getQualificationCertificateNumber())&&"".equals(jsonResolveObject.getQualificationCertificateNumber())) {
				list.add("qualificationCertificateNumber");
			}
			if (StringUtils.isBlank(jsonResolveObject.getPeriodStartDate())&&"".equals(jsonResolveObject.getPeriodStartDate())) {
				list.add("periodStartDate");
			}
			if (StringUtils.isBlank(jsonResolveObject.getPeriodEndDate())&&"".equals(jsonResolveObject.getPeriodEndDate())) {
				list.add("periodEndDate");
			}
			if (list.size() > 0) {
				ret.setCode(Constant.SUCCESS);
				ResultBody resultBody = new ResultBody();
				resultBody.setCode(3);
				resultBody.setResultList(list);
				ret.setResultBody(resultBody);
				ret.setResultCode(Constant.UN_MATCH_CODE);
				return ret;
			}
		   Map<String, Object> map = new HashMap<>();
		   map.put("nameOfPerson", jsonResolveObject.getNameOfPerson());
		   map.put("provinceCode", jsonResolveObject.getProvinceCode());
		   map.put("qualificationCertificateNumber", jsonResolveObject.getQualificationCertificateNumber());
		   String  body= JSON.toJSONString(map);
		   Response responseContext = PostUtil.postString(personUrl, body, appKey, appSecret,outTime);
		   log.info("supplier10000034.queryPerson接口responseContext={}", responseContext.getBody());
           PersonResponseObject responseObject = objectMapper.readValue(
					responseContext.getBody(), PersonResponseObject.class);
           log.info("supplier10000034.queryPerson接口responseObject={}", responseObject);
           if (responseObject != null) {
			ret.setCode(Constant.SUCCESS);
			if (SjjhConstants.RESULT_CODE_0.equals(responseObject.getResultCode())) {
				// 查询成功
				ret.setIsCharge(Constant.INTERFACE_QUERY_FEE);
				if(responseObject.getData().getNameOfPerson() == null || "".equals(responseObject.getData().getNameOfPerson())){
					list.add("periodStartDate");
				}
				if(responseObject.getData().getQualificationCertificateNumber() == null || "".equals(responseObject.getData().getQualificationCertificateNumber())){
					list.add("periodEndDate");
				}
				if(responseObject.getData().getPeriodStartDate() == null || "".equals(responseObject.getData().getPeriodStartDate())){
					list.add("periodStartDate");
				}
				if(responseObject.getData().getPeriodEndDate() == null || "".equals(responseObject.getData().getPeriodEndDate())){
					list.add("periodEndDate");
				}
				if(list.size() > 0){
					//数据源为空响应
					ret.setResultCode(Constant.UN_MATCH_CODE);
					ResultBody resultBody = new ResultBody();
					resultBody.setCode(1);
					resultBody.setResultList(list);
					ret.setResultBody(resultBody);
				}else{
					SimpleDateFormat sdf=new SimpleDateFormat("yyyyMMdd");
					if (!sdf.parse(jsonResolveObject.getPeriodStartDate()).equals(sdf.parse(responseObject.getData().getPeriodStartDate()))) {
						 list.add("periodStartDate");
					}
					if (!sdf.parse(jsonResolveObject.getPeriodEndDate()).equals(sdf.parse(responseObject.getData().getPeriodEndDate()))) {
						 list.add("periodEndDate");
					}
					if (!jsonResolveObject.getNameOfPerson().equals(responseObject.getData().getNameOfPerson())) {
						list.add("nameOfPerson");
					}
					if (!jsonResolveObject.getQualificationCertificateNumber().equals(responseObject.getData().getQualificationCertificateNumber())) {
						list.add("qualificationCertificateNumber"); 
					}
					if(list.size() > 0){
						//数据不一致响应
						ret.setResultCode(Constant.UN_MATCH_CODE);
						ResultBody resultBody = new ResultBody();
						resultBody.setCode(2);
						resultBody.setResultList(list);
						ret.setResultBody(resultBody);
					}else {
						//数据一致响应
						ret.setResultCode(Constant.MATCH_CODE);
						ret.setResultBody("一致");
					}
					
				}
			}else {
				// 查询为空或其他错误
				ResultBody resultBody = new ResultBody();
				resultBody.setCode(3);
				list.add("nameOfPerson"); 
				list.add("qualificationCertificateNumber"); 
				list.add("periodStartDate");
				list.add("periodEndDate");
				list.add("provinceCode");
				resultBody.setResultList(list);
				ret.setResultBody(resultBody);
				ret.setResultCode(Constant.UN_MATCH_CODE);
			}
          }
		} catch (SocketTimeoutException ste) {
			 ErrorUtils.captureException(ste);
	            log.info("supplier10000034.queryPerson接口SocketTimeoutException={}", ste);
	            ret.setCode(Constant.REQUEST_TIMEOUT);
		} catch (UnrecognizedPropertyException upe) {
			log.info("supplier10000034.queryPerson接口-UnrecognizedPropertyException：{}", upe);
			ErrorUtils.captureException(upe);
			ret.setCode(Constant.SUCCESS);
			List<String> list=new ArrayList<String>();
			ResultBody resultBody = new ResultBody();
			resultBody.setCode(3);
			list.add("nameOfPerson"); 
			list.add("qualificationCertificateNumber"); 
			list.add("periodStartDate");
			list.add("periodEndDate");
			list.add("provinceCode");
			resultBody.setResultList(list);
			ret.setResultBody(resultBody);
			ret.setResultCode(Constant.UN_MATCH_CODE);
			return ret;
		} catch (Exception e) {
			log.info("supplier10000034.queryPerson接口-Exception：{}", e);
			ErrorUtils.captureException(e);
			ret.setCode(Constant.FAIL);
		}
		return ret;
	}

	/**
	 * 查询车辆道路运输许可证信息
	 *
	 * @param request
	 * @param customBody
	 * @param outTime
	 * @return
	 */
	@Override
	public ChannelTypeHandleResponseObject checkVehiclePermit(HttpServletRequest request, String customBody, int outTime) {

		ChannelTypeHandleResponseObject ret = new ChannelTypeHandleResponseObject();
		ret.setIsCharge(Constant.INTERFACE_QUERY_NO_FEE);
		String upstreamCode = "" + Constant.LOG_UPSTREAM_DEFAULT_RESPONSE_CODE;
		request.setAttribute(Constant.LOG_UPSTREAM_RESPONSE_CODE, upstreamCode);
		try {
			if (outTime <= SjjhConstants.PARA_ZERO) {
				outTime = Constant.HTTPCLIENT_CONNECTTIMEOUT;
			}
			log.info("checkVehiclePermit---customBody={},outTime={}", customBody, outTime);
			ObjectMapper objectMapper = new ObjectMapper();
			VehiclePermitJsonResolveObject jsonResolveObject = objectMapper.readValue(customBody,
					VehiclePermitJsonResolveObject.class);

			//参数校验
			log.info("supplier10000034.checkVehiclePermit---requestObject={}", jsonResolveObject);
			List<String> paramErrorResultList = new ArrayList<>();
			//车牌号
			if(StringUtils.isBlank(jsonResolveObject.getVehicleNumber())
					|| jsonResolveObject.getVehicleNumber().length() > 10
					|| (!(jsonResolveObject.getVehicleNumber().replaceAll("[\u4e00-\u9fa5]*[A-Z]*\\d*-*_*\\s*", "").length()==0))){
				paramErrorResultList.add("vehicleNumber");
			}
			//颜色代码只能是1、2
			if(StringUtils.isBlank(jsonResolveObject.getLicensePlateTypeCode())
					|| jsonResolveObject.getLicensePlateTypeCode().length() != 1
					|| (!"1".equals(jsonResolveObject.getLicensePlateTypeCode()) && !"2".equals(jsonResolveObject.getLicensePlateTypeCode()))){
				paramErrorResultList.add("licensePlateTypeCode");
			}
			//运输证
			if (StringUtils.isBlank(jsonResolveObject.getRoadTransportCertificateNumber())
					|| jsonResolveObject.getRoadTransportCertificateNumber().length() != 12
					|| (!jsonResolveObject.getRoadTransportCertificateNumber().matches("^[0-9]*$"))){
				paramErrorResultList.add("roadTransportCertificateNumber");
			}
			//起日期
			if (StringUtils.isBlank(jsonResolveObject.getPeriodStartDate())
					|| jsonResolveObject.getPeriodStartDate().length() != 8
					|| (!jsonResolveObject.getPeriodStartDate().matches("^[0-9]*$"))){
				paramErrorResultList.add("periodStartDate");
			}
			//起日期
			if (StringUtils.isBlank(jsonResolveObject.getPeriodEndDate())
					|| jsonResolveObject.getPeriodEndDate().length() != 8
					|| (!jsonResolveObject.getPeriodEndDate().matches("^[0-9]*$"))){
				paramErrorResultList.add("periodEndDate");
			}
			//起日期要小于止日期
			if(!(Integer.valueOf(jsonResolveObject.getPeriodStartDate()) < Integer.valueOf(jsonResolveObject.getPeriodEndDate()))){
				paramErrorResultList.add("periodStartDate");
				paramErrorResultList.add("periodEndDate");
			}

			if (paramErrorResultList.size() > 0) {
				ret.setCode(Constant.SUCCESS);
				ret.setResultCode(Constant.INVALID_PARAMETER_CODE);
				ret.setResultDesc(Constant.INVALID_PARAMETER);

				ResultBody resultBody = new ResultBody();
				resultBody.setCode(3);
				resultBody.setResultList(paramErrorResultList);
				ret.setResultBody(resultBody);

				return ret;
			}

			//请求的body,json格式
			String body = "{\"vehicleNumber\":\""+jsonResolveObject.getVehicleNumber()+"\","   //车辆牌照号
					+ "\"licensePlateTypeCode\":\""+jsonResolveObject.getLicensePlateTypeCode()+"\"}";

			info.aspirecn.iov.sjjh.supplier10000034.gjwl.Response response = PostUtil.postString(urlVehiclePermit, body, appKey, appSecret,outTime);
			String responseContext = response.getBody();

			log.info("supplier10000034.checkVehiclePermit接口responseContext={}", responseContext);

			VehiclePermitDetailsResponseObject responseObject = objectMapper.readValue(
					responseContext, VehiclePermitDetailsResponseObject.class);

			log.info("supplier10000034.checkVehiclePermit接口responseObject={}", responseObject);
			if (responseObject != null) {
				ret.setCode(Constant.SUCCESS);
				if (responseObject.getResultCode().equals(SjjhConstants.RESULT_CODE_0)) {
					// 查询成功
					ret.setIsCharge(Constant.INTERFACE_QUERY_FEE);
					//比对数据
					//1、源数据是否为空
					List<String> resultList = new ArrayList<>();
					if(responseObject.getData().getVehicleNumber() == null || "".equals(responseObject.getData().getVehicleNumber())){
						resultList.add("vehicleNumber");
					}
					if(responseObject.getData().getLicensePlateTypeCode() == null || "".equals(responseObject.getData().getLicensePlateTypeCode())){
						resultList.add("licensePlateTypeCode");
					}
					if(responseObject.getData().getRoadTransportCertificateNumber() == null || "".equals(responseObject.getData().getRoadTransportCertificateNumber())){
						resultList.add("roadTransportCertificateNumber");
					}
					if(responseObject.getData().getPeriodStartDate() == null || "".equals(responseObject.getData().getPeriodStartDate())){
						resultList.add("periodStartDate");
					}
					if(responseObject.getData().getPeriodEndDate() == null || "".equals(responseObject.getData().getPeriodEndDate())){
						resultList.add("periodEndDate");
					}

					if(resultList.size() > 0){
						//数据源为空响应
						ret.setResultCode(Constant.UN_MATCH_CODE);

						ResultBody resultBody = new ResultBody();
						resultBody.setCode(1);
						resultBody.setResultList(resultList);

						ret.setResultBody(resultBody);
					}else{
						//2、数据是否一致
						if( !jsonResolveObject.getVehicleNumber().equals(responseObject.getData().getVehicleNumber())){
							resultList.add("vehicleNumber");
						}
						if( !jsonResolveObject.getLicensePlateTypeCode().equals(responseObject.getData().getLicensePlateTypeCode())){
							resultList.add("licensePlateTypeCode");
						}
						if( !jsonResolveObject.getRoadTransportCertificateNumber().equals(responseObject.getData().getRoadTransportCertificateNumber())){
							resultList.add("roadTransportCertificateNumber");
						}
						if( !jsonResolveObject.getPeriodStartDate().equals(responseObject.getData().getPeriodStartDate())){
							resultList.add("periodStartDate");
						}
						if( !jsonResolveObject.getPeriodEndDate().equals(responseObject.getData().getPeriodEndDate())){
							resultList.add("periodEndDate");
						}

						if(resultList.size() > 0){
							//数据不一致响应
							ret.setResultCode(Constant.UN_MATCH_CODE);

							ResultBody resultBody = new ResultBody();
							resultBody.setCode(2);
							resultBody.setResultList(resultList);

							ret.setResultBody(resultBody);
						}else {
							//数据一致响应
							ret.setResultCode(Constant.MATCH_CODE);
							//ret.setResultBody("一致");
						}
					}

				}else {
					// 其他错误
					ret.setResultCode(Constant.UN_MATCH_CODE);

					ResultBody resultBody = new ResultBody();
					resultBody.setCode(3);
					List<String> resultList = new ArrayList<>();
					resultList.add("vehicleNumber");
					resultList.add("licensePlateTypeCode");
					resultList.add("roadTransportCertificateNumber");
					resultList.add("periodStartDate");
					resultList.add("periodEndDate");
					resultBody.setResultList(resultList);

					ret.setResultBody(resultBody);

				}

				request.setAttribute(Constant.LOG_UPSTREAM_RESPONSE_CODE, responseObject.getResultCode());
			} else {
				ret.setCode(Constant.FAIL);
			}

		} catch (SocketTimeoutException ste) {
			ErrorUtils.captureException(ste);
			log.info("supplier10000034.checkVehiclePermit接口SocketTimeoutException={}", ste);
			ret.setCode(Constant.REQUEST_TIMEOUT);
		} catch (UnrecognizedPropertyException upe) {
			log.info("supplier10000034.checkVehiclePermit接口-UnrecognizedPropertyException：{}", upe);
			ErrorUtils.captureException(upe);
			ret.setCode(Constant.SUCCESS);
			ret.setIsCharge(Constant.IS_NOT_CHARGE);
			/** 参数错误 */
			ret.setResultCode(Constant.INVALID_PARAMETER_CODE);

			ResultBody resultBody = new ResultBody();
			resultBody.setCode(3);
			List<String> resultList = new ArrayList<>();
			resultList.add("vehicleNumber");
			resultList.add("licensePlateTypeCode");
			resultList.add("roadTransportCertificateNumber");
			resultList.add("periodStartDate");
			resultList.add("periodEndDate");
			resultBody.setResultList(resultList);
			ret.setResultBody(resultBody);

			ret.setResultDesc(Constant.PARAMETER_NAME_ERROR);
			return ret;
		} catch (IOException ioe) {
			log.info("supplier10000034.checkVehiclePermit接口-Exception：{}", ioe);
			ErrorUtils.captureException(ioe);
			ret.setCode(Constant.FAIL);
		} catch (Exception ioe) {
			log.info("supplier10000034.checkVehiclePermit接口-Exception：{}", ioe);
			ErrorUtils.captureException(ioe);
			ret.setCode(Constant.FAIL);
		}
		return ret;
	}

	/**
	 * 车辆入网核验
	 *
	 * @param request
	 * @param customBody
	 * @param outTime
	 * @return
	 */
	@Override
	public ChannelTypeHandleResponseObject checkVehicleExist(HttpServletRequest request, String customBody, int outTime) {

		ChannelTypeHandleResponseObject ret = new ChannelTypeHandleResponseObject();
		ret.setIsCharge(Constant.INTERFACE_QUERY_NO_FEE);
		String upstreamCode = "" + Constant.LOG_UPSTREAM_DEFAULT_RESPONSE_CODE;
		request.setAttribute(Constant.LOG_UPSTREAM_RESPONSE_CODE, upstreamCode);
		try {
			if (outTime <= SjjhConstants.PARA_ZERO) {
				outTime = Constant.HTTPCLIENT_CONNECTTIMEOUT;
			}
			log.info("checkVehicleExist---customBody={},outTime={}", customBody, outTime);
			ObjectMapper objectMapper = new ObjectMapper();
			VehicleInToNetResolveObject jsonResolveObject = objectMapper.readValue(customBody,
					VehicleInToNetResolveObject.class);
			log.info("supplier10000034.checkVehicleExist---requestObject={}", jsonResolveObject);

			//参数核验
			List<String> paramErrorResultList = new ArrayList<>();
			//车牌号
			if(StringUtils.isBlank(jsonResolveObject.getVehicleNumber())
					|| jsonResolveObject.getVehicleNumber().length() > 10
					|| (!(jsonResolveObject.getVehicleNumber().replaceAll("[\u4e00-\u9fa5]*[A-Z]*\\d*-*_*\\s*", "").length()==0))){
				paramErrorResultList.add("vehicleNumber");
			}
			//颜色代码只能是1、2
			if(StringUtils.isBlank(jsonResolveObject.getLicensePlateTypeCode())
					|| jsonResolveObject.getLicensePlateTypeCode().length() != 1
					|| (!"1".equals(jsonResolveObject.getLicensePlateTypeCode()) && !"2".equals(jsonResolveObject.getLicensePlateTypeCode()))){
				paramErrorResultList.add("licensePlateTypeCode");
			}

			if (paramErrorResultList.size() > 0) {
				ret.setCode(Constant.SUCCESS);
				ret.setResultCode(Constant.INVALID_PARAMETER_CODE);
				ret.setResultDesc(Constant.INVALID_PARAMETER);

				ResultBody resultBody = new ResultBody();
				resultBody.setCode(3);
				resultBody.setResultList(paramErrorResultList);
				ret.setResultBody(resultBody);

				return ret;
			}

			info.aspirecn.iov.sjjh.supplier10000034.gjwl.Response response = PostUtil.postString(urlCheckVehicleExist, customBody, appKey, appSecret,outTime);
			String responseContext = response.getBody();

			log.info("supplier10000034.checkVehicleExist接口responseContext={}", responseContext);
			CheckVehicleExistResponseObject responseObject = objectMapper.readValue(
					responseContext, CheckVehicleExistResponseObject.class);
			log.info("supplier10000034.checkVehicleExist接口responseObject={}", responseObject);
			if (responseObject != null) {
				ret.setCode(Constant.SUCCESS);
				if (responseObject.getResultCode().equals(SjjhConstants.RESULT_CODE_0)) {
					// 查询成功
					ret.setIsCharge(Constant.INTERFACE_QUERY_FEE);
					ret.setResultDesc(SjjhConstants.INTERFACE_SUCCESS_TEXT);
					if ("1".equals(responseObject.getData())) {
						ret.setResultCode(Constant.MATCH_CODE);
					}else {
						//数据不一致响应
						ret.setResultCode(Constant.UN_MATCH_CODE);
						ResultBody resultBody = new ResultBody();
						List<String> resultList = new ArrayList<>();
				    	resultList.add("vehicleNumber");
				    	resultList.add("licensePlateTypeCode");
						resultBody.setCode(2);
						resultBody.setResultList(resultList);
						ret.setResultBody(resultBody);
					}
				}else{
					// 其他错误
					ret.setResultCode(Constant.OTHER_ERROR_CODE);

					ResultBody resultBody = new ResultBody();
					resultBody.setCode(3);
					List<String> resultList = new ArrayList<>();
					resultList.add("vehicleNumber");
					resultList.add("licensePlateTypeCode");
					resultBody.setResultList(resultList);
					ret.setResultBody(resultBody);

					ret.setResultDesc(Constant.OTHER_ERROR);
				}

				request.setAttribute(Constant.LOG_UPSTREAM_RESPONSE_CODE, responseObject.getResultCode());
			} else {
				ret.setCode(Constant.FAIL);
			}

		} catch (SocketTimeoutException ste) {
			ErrorUtils.captureException(ste);
			log.info("supplier10000034.checkVehicleExist接口SocketTimeoutException={}", ste);
			ret.setCode(Constant.REQUEST_TIMEOUT);
		} catch (UnrecognizedPropertyException upe) {
			log.info("supplier10000034.checkVehicleExist接口-UnrecognizedPropertyException：{}", upe);
			ErrorUtils.captureException(upe);
			ret.setCode(Constant.SUCCESS);
			ret.setIsCharge(Constant.IS_NOT_CHARGE);
			/** 参数错误 */
			ret.setResultCode(Constant.INVALID_PARAMETER_CODE);

			ResultBody resultBody = new ResultBody();
			resultBody.setCode(3);
			List<String> resultList = new ArrayList<>();
			resultList.add("vehicleNumber");
			resultList.add("licensePlateTypeCode");
			resultBody.setResultList(resultList);
			ret.setResultBody(resultBody);

			ret.setResultDesc(Constant.PARAMETER_NAME_ERROR);
			return ret;
		} catch (IOException ioe) {
			log.info("supplier10000034.checkVehicleExist接口-Exception：{}", ioe);
			ErrorUtils.captureException(ioe);
			ret.setCode(Constant.FAIL);
		} catch (Exception ioe) {
			log.info("supplier10000034.checkVehicleExist接口-Exception：{}", ioe);
			ErrorUtils.captureException(ioe);
			ret.setCode(Constant.FAIL);
		}
		return ret;
	}
	/**
	 *查询运政企业信息-数据信用
	 */
	@Override
	public ChannelTypeHandleResponseObject queryEnterpriseSjxy(HttpServletRequest request, String customBody,
															   int outTime) {

		ChannelTypeHandleResponseObject ret = new ChannelTypeHandleResponseObject();
		ret.setCode(Constant.SUCCESS);
		ret.setIsCharge(Constant.INTERFACE_QUERY_NO_FEE);
		String upstreamCode = "" + Constant.LOG_UPSTREAM_DEFAULT_RESPONSE_CODE;

		try {
			if (outTime <= SjjhConstants.PARA_ZERO) {
				outTime = Constant.HTTPCLIENT_CONNECTTIMEOUT;
			}
			log.info("queryEnterprise---customBody={},outTime={}",customBody,outTime);
			ObjectMapper objectMapper = new ObjectMapper();
			EnterpriseSjxyRequestObject enterpriseRequestObject=objectMapper.readValue(customBody,
					EnterpriseSjxyRequestObject.class);
			log.info("supplier10000034.queryEnterpriseSjxy---requestObject={}", enterpriseRequestObject);
			List<String> list=new ArrayList<String>();
			String enterpriseName = enterpriseRequestObject.getCarrier();
			String provinceCode = enterpriseRequestObject.getProvinceCode();
			if(StringUtils.isEmpty(enterpriseName)||StringUtils.isEmpty(provinceCode)){

			}

			Map<String, Object> map = new HashMap<>();
			map.put("enterpriseName", enterpriseName);
			map.put("provinceCode", provinceCode.substring(0, 2)+"0000");
			String  body= objectMapper.writeValueAsString(map);
			Response responseContext = PostUtil.postString(enterpriseUrl, body, appKey, appSecret,outTime);
			log.info("supplier10000034.queryEnterprise接口responseContext={}", responseContext.getBody());
			EnterpriseResponseObject responseObject = objectMapper.readValue(
					responseContext.getBody(), EnterpriseResponseObject.class);
			log.info("supplier10000034.queryEnterprise接口responseObject={}", responseObject);
			if (responseObject != null) {
				upstreamCode = responseObject.getResultCode();
				if (SjjhConstants.RESULT_CODE_0.equals(responseObject.getResultCode())) {//成功
					// 查询成功
					ret.setIsCharge(Constant.IS_CHARGE);
					ret.setResultCode(Constant.MATCH_CODE);
					ret.setResultBody(responseObject.getData());
					ret.setResultDesc(SjjhConstants.QUERY_RESULT);
				}else if(SjjhConstants.INTERFACE_CODE_140001.equals(responseObject.getResultCode())||SjjhConstants.INTERFACE_CODE_140002.equals(responseObject.getResultCode())){//必填参数为空,参数不符合我规格

					ret.setResultCode(Constant.INVALID_PARAMETER_CODE);
					ret.setResultBody(Constant.INVALID_PARAMETER);
					ret.setResultDesc(Constant.INVALID_PARAMETER);
				}else if(SjjhConstants.INTERFACE_CODE_110000.equals(responseObject.getResultCode())){
					ret.setResultCode(Constant.UN_FIND_NUM_CODE);
					ret.setResultBody(SjjhConstants.QUERY_NO_RESULT);
					ret.setResultDesc(SjjhConstants.QUERY_NO_RESULT);
				}else{
					ret.setResultCode(Constant.OTHER_ERROR_CODE);
					ret.setResultDesc(Constant.OTHER_ERROR);
					ret.setResultBody(Constant.OTHER_ERROR);
				}
			}else{
				ret.setResultCode(Constant.OTHER_ERROR_CODE);
				ret.setResultDesc(Constant.OTHER_ERROR);
				ret.setResultBody(Constant.OTHER_ERROR);
			}

		}catch (SocketTimeoutException ste) {
			ErrorUtils.captureException(ste);
			log.info("supplier10000034.queryEnterprise接口SocketTimeoutException={}", ste);
			ret.setCode(Constant.REQUEST_TIMEOUT);
		}  catch (Exception e) {
			log.info("supplier10000034.queryEnterprise接口-Exception：{}", e);
			ErrorUtils.captureException(e);
			ret.setCode(Constant.FAIL);
		}
		request.setAttribute(Constant.LOG_UPSTREAM_RESPONSE_CODE, upstreamCode);
		return ret;
	}
	/**
	 *查询运政人员信息
	 */
	@Override
	public ChannelTypeHandleResponseObject queryPersonSjxy(HttpServletRequest request, String customBody,
														   int outTime) {

		ChannelTypeHandleResponseObject ret = new ChannelTypeHandleResponseObject();
		ret.setCode(Constant.SUCCESS);
		ret.setIsCharge(Constant.INTERFACE_QUERY_NO_FEE);
		String upstreamCode = "" + Constant.LOG_UPSTREAM_DEFAULT_RESPONSE_CODE;

		try {
			if (outTime <= SjjhConstants.PARA_ZERO) {
				outTime = Constant.HTTPCLIENT_CONNECTTIMEOUT;
			}
			log.info("queryPersonSjxy---customBody={},outTime={}",customBody,outTime);

			PersonSjxyRequestObject personInfoObject=objectMapper.readValue(customBody,
					PersonSjxyRequestObject.class);
			log.info("supplier10000034.queryPersonSjxy---requestObject={}", personInfoObject);

			String name = personInfoObject.getNameOfPerson();
			String idCode = personInfoObject.getIdentityDocumentNumber();
			String qualificationCertificateNumber=personInfoObject.getQualificationCertificateNumber();
			String provinceCode=personInfoObject.getProvinceCode();
			if(StringUtils.isEmpty(name)||(StringUtils.isEmpty(idCode)&&StringUtils.isEmpty(qualificationCertificateNumber))||StringUtils.isEmpty(provinceCode)){
				ret.setResultCode(Constant.INVALID_PARAMETER_CODE);
				ret.setResultBody(Constant.INVALID_PARAMETER);
				ret.setResultDesc(Constant.INVALID_PARAMETER);
				return ret;
			}
			if(!PatternTools.checkResult(Constant.PATTERN_CN_NAME_REGEX,name)
					||(StringUtils.isNotEmpty(idCode) && !PatternTools.checkResult(Constant.PATTERN_ID_NUMBER_REGEX,idCode)
					||provinceCode.length()!=6||!"0000".equals(provinceCode.substring(2)))){
				ret.setResultCode(Constant.INVALID_PARAMETER_CODE);
				ret.setResultBody(Constant.INVALID_PARAMETER);
				ret.setResultDesc(Constant.INVALID_PARAMETER);
				return ret;
			}
			String 	body = objectMapper.writeValueAsString(personInfoObject);
			log.info("requestBody:{}",body);
			Response responseContext = PostUtil.postString(personUrl, body, appKey, appSecret,outTime);
			log.info("supplier10000034.queryPersonSjxy接口responseContext={}", responseContext.getBody());
			PersonResponseObject responseObject = objectMapper.readValue(
					responseContext.getBody(), PersonResponseObject.class);
			log.info("supplier10000034.queryPersonSjxy接口responseObject={}", responseObject);
			if (responseObject != null) {
				upstreamCode = responseObject.getResultCode();
				if (SjjhConstants.RESULT_CODE_0.equals(responseObject.getResultCode())) {//成功
					// 查询成功
					ret.setIsCharge(Constant.IS_CHARGE);
					ret.setResultCode(Constant.MATCH_CODE);
					ret.setResultBody(responseObject.getData());
					ret.setResultDesc(SjjhConstants.QUERY_RESULT);
				}else if(SjjhConstants.INTERFACE_CODE_140001.equals(responseObject.getResultCode())||SjjhConstants.INTERFACE_CODE_140002.equals(responseObject.getResultCode())){//必填参数为空,参数不符合我规格

					ret.setResultCode(Constant.INVALID_PARAMETER_CODE);
					ret.setResultBody(Constant.INVALID_PARAMETER);
					ret.setResultDesc(Constant.INVALID_PARAMETER);
				}else if(SjjhConstants.INTERFACE_CODE_110000.equals(responseObject.getResultCode())){
					ret.setResultCode(Constant.UN_FIND_NUM_CODE);
					ret.setResultBody(SjjhConstants.QUERY_NO_RESULT);
					ret.setResultDesc(SjjhConstants.QUERY_NO_RESULT);
				}else{
					ret.setResultCode(Constant.OTHER_ERROR_CODE);
					ret.setResultDesc(Constant.OTHER_ERROR);
					ret.setResultBody(Constant.OTHER_ERROR);
				}
			}else{
				ret.setResultCode(Constant.OTHER_ERROR_CODE);
				ret.setResultDesc(Constant.OTHER_ERROR);
				ret.setResultBody(Constant.OTHER_ERROR);
			}
		} catch (SocketTimeoutException ste) {
			ErrorUtils.captureException(ste);
			log.info("supplier10000034.queryPerson接口SocketTimeoutException={}", ste);
			ret.setCode(Constant.REQUEST_TIMEOUT);
		} catch (Exception e) {
			log.info("supplier10000034.queryPerson接口-Exception：{}", e);
			ErrorUtils.captureException(e);
			ret.setCode(Constant.FAIL);
		}
		request.setAttribute(Constant.LOG_UPSTREAM_RESPONSE_CODE, upstreamCode);
		return ret;
	}

	/**
	 * 查询车辆道路运输许可证信息-数据信用
	 *
	 * @param request
	 * @param customBody
	 * @param outTime
	 * @return
	 */
	@Override
	public ChannelTypeHandleResponseObject checkVehiclePermitSjxy(HttpServletRequest request, String customBody, int outTime) {

		ChannelTypeHandleResponseObject ret = new ChannelTypeHandleResponseObject();
		ret.setCode(Constant.SUCCESS);
		ret.setIsCharge(Constant.INTERFACE_QUERY_NO_FEE);
		String upstreamCode = "" + Constant.LOG_UPSTREAM_DEFAULT_RESPONSE_CODE;

		try {
			if (outTime <= SjjhConstants.PARA_ZERO) {
				outTime = Constant.HTTPCLIENT_CONNECTTIMEOUT;
			}
			log.info("checkVehiclePermitSjxy---customBody={},outTime={}", customBody, outTime);
			VehiclePermitSjxyRequstObject jsonResolveObject = objectMapper.readValue(customBody,
					VehiclePermitSjxyRequstObject.class);

			//参数校验
			log.info("supplier10000034.checkVehiclePermitSjxy---requestObject={}", jsonResolveObject);

			boolean bool = StringUtils.isBlank(jsonResolveObject.getVehicleNumber())
					|| !PatternTools.checkResult(Constant.PATTERN_CAR_NUMBER_REGEX, jsonResolveObject.getVehicleNumber())
					|| (StringUtils.isNotBlank(jsonResolveObject.getLicensePlateTypeCode())
					&& !ArrayUtils.contains(CAR_COLOR_ARRAY, jsonResolveObject.getLicensePlateTypeCode()));
			if(bool){

					ret.setResultCode(Constant.INVALID_PARAMETER_CODE);
				ret.setResultDesc(Constant.INVALID_PARAMETER);
				ret.setResultBody(Constant.INVALID_PARAMETER);
				return ret;
			}
			String body = objectMapper.writeValueAsString(jsonResolveObject);
			log.info("requestBody:{}",body);
			info.aspirecn.iov.sjjh.supplier10000034.gjwl.Response response = PostUtil.postString(urlVehiclePermit, body, appKey, appSecret,outTime);
			String responseContext = response.getBody();

			log.info("supplier10000034.checkVehiclePermitSjxy接口responseContext={}", responseContext);

			VehiclePermitDetailsResponseObject responseObject = objectMapper.readValue(
					responseContext, VehiclePermitDetailsResponseObject.class);

			log.info("supplier10000034.checkVehiclePermitSjxy接口responseObject={}", responseObject);
			if (responseObject != null) {
				upstreamCode = responseObject.getResultCode();
				if (SjjhConstants.RESULT_CODE_0.equals(responseObject.getResultCode())) {//成功
					// 查询成功
					ret.setIsCharge(Constant.IS_CHARGE);
					ret.setResultCode(Constant.MATCH_CODE);
					ret.setResultBody(responseObject.getData());
					ret.setResultDesc(SjjhConstants.QUERY_RESULT);
				}else if(SjjhConstants.INTERFACE_CODE_140001.equals(responseObject.getResultCode())||SjjhConstants.INTERFACE_CODE_140002.equals(responseObject.getResultCode())){//必填参数为空,参数不符合我规格

					ret.setResultCode(Constant.INVALID_PARAMETER_CODE);
					ret.setResultBody(Constant.INVALID_PARAMETER);
					ret.setResultDesc(Constant.INVALID_PARAMETER);
				}else if(SjjhConstants.INTERFACE_CODE_110000.equals(responseObject.getResultCode())){
					ret.setResultCode(Constant.UN_FIND_NUM_CODE);
					ret.setResultBody(SjjhConstants.QUERY_NO_RESULT);
					ret.setResultDesc(SjjhConstants.QUERY_NO_RESULT);
				}else{
					ret.setResultCode(Constant.OTHER_ERROR_CODE);
					ret.setResultDesc(Constant.OTHER_ERROR);
					ret.setResultBody(Constant.OTHER_ERROR);
				}
			}else{
				ret.setResultCode(Constant.OTHER_ERROR_CODE);
				ret.setResultDesc(Constant.OTHER_ERROR);
				ret.setResultBody(Constant.OTHER_ERROR);
			}
		} catch (SocketTimeoutException ste) {
			ErrorUtils.captureException(ste);
			log.info("supplier10000034.queryPerson接口SocketTimeoutException={}", ste);
			ret.setCode(Constant.REQUEST_TIMEOUT);
		} catch (Exception e) {
			log.info("supplier10000034.queryPerson接口-Exception：{}", e);
			ErrorUtils.captureException(e);
			ret.setCode(Constant.FAIL);
		}
		request.setAttribute(Constant.LOG_UPSTREAM_RESPONSE_CODE, upstreamCode);
		return ret;
	}

	/**
	 * 车辆入网核验-数据信用
	 *
	 * @param request
	 * @param customBody
	 * @param outTime
	 * @return
	 */
	@Override
	public ChannelTypeHandleResponseObject checkVehicleExistSjxy(HttpServletRequest request, String customBody, int outTime) {

		ChannelTypeHandleResponseObject ret = new ChannelTypeHandleResponseObject();
		ret.setCode(Constant.SUCCESS);
		ret.setIsCharge(Constant.INTERFACE_QUERY_NO_FEE);
		String upstreamCode = "" + Constant.LOG_UPSTREAM_DEFAULT_RESPONSE_CODE;

		try {
			if (outTime <= SjjhConstants.PARA_ZERO) {
				outTime = Constant.HTTPCLIENT_CONNECTTIMEOUT;
			}
			log.info("checkVehicleExistSjxy---customBody={},outTime={}", customBody, outTime);
			VehicleExistSjxyRequestObject jsonResolveObject = objectMapper.readValue(customBody,
					VehicleExistSjxyRequestObject.class);

			Map<String, Object> map = new HashMap<>();
			map.put("vehicleNumber",jsonResolveObject.getPlateNum());
			map.put("licensePlateTypeCode",jsonResolveObject.getPlateColor());
			String body = objectMapper.writeValueAsString(map);
			log.info("requestBody:{}",body);
			info.aspirecn.iov.sjjh.supplier10000034.gjwl.Response response = PostUtil.postString(urlCheckVehicleExist, body, appKey, appSecret,outTime);
			String responseContext = response.getBody();

			log.info("supplier10000034.checkVehicleExist接口responseContext={}", responseContext);
			CheckVehicleExistResponseObject responseObject = objectMapper.readValue(
					responseContext, CheckVehicleExistResponseObject.class);
			log.info("supplier10000034.checkVehicleExist接口responseObject={}", responseObject);
			if (responseObject != null) {
				upstreamCode = responseObject.getResultCode();
				if (SjjhConstants.RESULT_CODE_0.equals(responseObject.getResultCode())) {//成功
					// 查询成功
					ret.setIsCharge(Constant.IS_CHARGE);

					if("1".equals(responseObject.getData())){
						ret.setResultBody("是");
						ret.setResultCode(Constant.MATCH_CODE);
					}else if("0".equals(responseObject.getData())){
						ret.setResultBody("否");
						ret.setResultCode(Constant.UN_MATCH_CODE);
					}

					ret.setResultDesc(SjjhConstants.QUERY_RESULT);
				}else if(SjjhConstants.INTERFACE_CODE_140001.equals(responseObject.getResultCode())||SjjhConstants.INTERFACE_CODE_140002.equals(responseObject.getResultCode())){//必填参数为空,参数不符合我规格

					ret.setResultCode(Constant.INVALID_PARAMETER_CODE);
					ret.setResultBody(Constant.INVALID_PARAMETER);
					ret.setResultDesc(Constant.INVALID_PARAMETER);
				}else if(SjjhConstants.INTERFACE_CODE_110000.equals(responseObject.getResultCode())){
					ret.setResultCode(Constant.UN_FIND_NUM_CODE);
					ret.setResultBody(SjjhConstants.QUERY_NO_RESULT);
					ret.setResultDesc(SjjhConstants.QUERY_NO_RESULT);
				}else{
					ret.setResultCode(Constant.OTHER_ERROR_CODE);
					ret.setResultDesc(Constant.OTHER_ERROR);
					ret.setResultBody(Constant.OTHER_ERROR);
				}
			}else{
				ret.setResultCode(Constant.OTHER_ERROR_CODE);
				ret.setResultDesc(Constant.OTHER_ERROR);
				ret.setResultBody(Constant.OTHER_ERROR);
			}
		} catch (SocketTimeoutException ste) {
			ErrorUtils.captureException(ste);
			log.info("supplier10000034.queryPerson接口SocketTimeoutException={}", ste);
			ret.setCode(Constant.REQUEST_TIMEOUT);
		} catch (Exception e) {
			log.info("supplier10000034.queryPerson接口-Exception：{}", e);
			ErrorUtils.captureException(e);
			ret.setCode(Constant.FAIL);
		}
		request.setAttribute(Constant.LOG_UPSTREAM_RESPONSE_CODE, upstreamCode);
		return ret;
	}
	/**
	  * @param nowTime   当前时间
	  * @param beginTime 开始时间
	  * @param endTime   结束时间
	  * @return 如果当前时间在开始时间和结束时间之内就返回true，否则返回false
	  */
	 public static boolean belongCalendar(Date nowTime, Date beginTime, Date endTime) {
	     Calendar date = Calendar.getInstance();
	     date.setTime(nowTime);
	     Calendar begin = Calendar.getInstance();
	     begin.setTime(beginTime);
	     Calendar end = Calendar.getInstance();
	     end.setTime(endTime);
	     if (date.after(begin) && date.before(end)) {
	         return true;
	     } else if (nowTime.compareTo(beginTime) == 0 || nowTime.compareTo(endTime) == 0) {
	         return true;
	     } else {
	         return false;
	     }
	 }
	 /**检验公司名称*/
	 public static boolean isChinese(String chinese) {
	    return chinese.matches("[\\u4e00-\\u9fa5]+");
	 }
	  /**检验省区划代码*/
	 public static boolean isNumber(String number) {
		Pattern pattern = Pattern.compile("\\d{6}");
	    return pattern.matcher(number).matches();
	 }


	/**
	 * 超载核验
	 *
	 * @param request
	 * @param customBody
	 * @param outTime
	 * @return
	 */
	@Override
	public ChannelTypeHandleResponseObject overloadCheck(HttpServletRequest request, String customBody, int outTime) {

		ChannelTypeHandleResponseObject ret = new ChannelTypeHandleResponseObject();
		ret.setIsCharge(Constant.INTERFACE_QUERY_NO_FEE);
		String upstreamCode = "" + Constant.LOG_UPSTREAM_DEFAULT_RESPONSE_CODE;
		request.setAttribute(Constant.LOG_UPSTREAM_RESPONSE_CODE, upstreamCode);
		try {
			if (outTime <= SjjhConstants.PARA_ZERO) {
				outTime = Constant.HTTPCLIENT_CONNECTTIMEOUT;
			}
			log.info("overloadCheck---customBody={},outTime={}", customBody, outTime);
			ObjectMapper objectMapper = new ObjectMapper();
			OverloadCheckJsonResolveObject jsonResolveObject = objectMapper.readValue(customBody,
					OverloadCheckJsonResolveObject.class);

			//参数校验
			log.info("supplier10000034.overloadCheck---requestObject={}", jsonResolveObject);
			List<String> paramErrorResultList = new ArrayList<>();
			//车牌号
			if(StringUtils.isBlank(jsonResolveObject.getVehicleNumber())
					|| jsonResolveObject.getVehicleNumber().length() > 10
					|| (!(jsonResolveObject.getVehicleNumber().replaceAll("[\u4e00-\u9fa5]*[A-Z]*\\d*-*_*\\s*", "").length()==0))){
				paramErrorResultList.add("vehicleNumber");
			}
			//颜色代码只能是1、2
			if(StringUtils.isBlank(jsonResolveObject.getLicensePlateTypeCode())
				|| jsonResolveObject.getLicensePlateTypeCode().length() != 1
				|| (!"1".equals(jsonResolveObject.getLicensePlateTypeCode()) && !"2".equals(jsonResolveObject.getLicensePlateTypeCode()))){
				paramErrorResultList.add("licensePlateTypeCode");
			}
			//货物毛重
			if (StringUtils.isBlank(jsonResolveObject.getVehicleTonnage())
				|| jsonResolveObject.getVehicleTonnage().length() > 9
				|| (!jsonResolveObject.getVehicleTonnage().matches("^[+-]?\\d+(\\.\\d+)?$"))){
				paramErrorResultList.add("vehicleTonnage");
			}

			if (paramErrorResultList.size() > 0) {
				ret.setCode(Constant.SUCCESS);
				ret.setResultCode(Constant.INVALID_PARAMETER_CODE);
				ret.setResultDesc(Constant.INVALID_PARAMETER);

				ResultBody resultBody = new ResultBody();
				resultBody.setCode(3);
				resultBody.setResultList(paramErrorResultList);
				ret.setResultBody(resultBody);
				return ret;
			}

			//请求的body,json格式
			String body = "{\"vehicleNumber\":\""+jsonResolveObject.getVehicleNumber()+"\","   //车辆牌照号
					+ "\"licensePlateTypeCode\":\""+jsonResolveObject.getLicensePlateTypeCode()+"\"}";

			info.aspirecn.iov.sjjh.supplier10000034.gjwl.Response response = PostUtil.postString(urlVehiclePermit, body, appKey, appSecret,outTime);
			String responseContext = response.getBody();

			log.info("supplier10000034.overloadCheck接口responseContext={}", responseContext);

			VehiclePermitDetailsResponseObject responseObject = objectMapper.readValue(
					responseContext, VehiclePermitDetailsResponseObject.class);

			log.info("supplier10000034.overloadCheck接口responseObject={}", responseObject);
			if (responseObject != null) {
				ret.setCode(Constant.SUCCESS);
				if (responseObject.getResultCode().equals(SjjhConstants.RESULT_CODE_0)) {
					// 查询成功
					ret.setIsCharge(Constant.INTERFACE_QUERY_FEE);
					//比对数据
					//1、源数据是否为空
					List<String> resultList = new ArrayList<>();
					if(responseObject.getData().getVehicleNumber() == null || "".equals(responseObject.getData().getVehicleNumber())){
						resultList.add("vehicleNumber");
					}
					if(responseObject.getData().getLicensePlateTypeCode() == null || "".equals(responseObject.getData().getLicensePlateTypeCode())){
						resultList.add("licensePlateTypeCode");
					}
					//返回的载重不是数值也算作空
					if(responseObject.getData().getVehicleTonnage() == null || "".equals(responseObject.getData().getRoadTransportCertificateNumber())
							|| !responseObject.getData().getVehicleTonnage().matches("^[+-]?\\d+(\\.\\d+)?$")){
						resultList.add("vehicleTonnage");
					}

					if(resultList.size() > 0){
						//数据源为空响应
						ret.setResultCode(Constant.UN_MATCH_CODE);

						ResultBody resultBody = new ResultBody();
						resultBody.setCode(1);
						resultBody.setResultList(resultList);

						ret.setResultBody(resultBody);
					}else{

						//判断超载
						if(Double.valueOf(jsonResolveObject.getVehicleTonnage()) <= Double.valueOf(responseObject.getData().getVehicleTonnage())){
							ret.setResultCode(Constant.MATCH_CODE);

						}else {
							ret.setResultCode(Constant.UN_MATCH_CODE);
							ret.setResultBody("超载");
						}

						/*//2、数据是否一致
						if( !jsonResolveObject.getVehicleNumber().equals(responseObject.getData().getVehicleNumber())){
							resultList.add("vehicleNumber");
						}
						if( !jsonResolveObject.getLicensePlateTypeCode().equals(responseObject.getData().getLicensePlateTypeCode())){
							resultList.add("licensePlateTypeCode");
						}
						if( !jsonResolveObject.getVehicleTonnage().equals(responseObject.getData().getVehicleTonnage())){
							resultList.add("vehicleTonnage");
						}

						if(resultList.size() > 0){
							//数据不一致响应
							ret.setResultCode(Constant.UN_MATCH_CODE);

							ResultBody resultBody = new ResultBody();
							resultBody.setCode(2);
							resultBody.setResultList(resultList);

							ret.setResultBody(resultBody);
						}else {
							//数据一致响应
							ret.setResultCode(Constant.MATCH_CODE);
							//ret.setResultBody("一致");
						}*/
					}

				}else{
					// 其他错误
					ret.setResultCode(Constant.UN_MATCH_CODE);

					ResultBody resultBody = new ResultBody();
					resultBody.setCode(3);
					List<String> resultList = new ArrayList<>();
					resultList.add("vehicleNumber");
					resultList.add("licensePlateTypeCode");
					resultList.add("vehicleTonnage");
					resultBody.setResultList(resultList);

					ret.setResultBody(resultBody);

				}

				request.setAttribute(Constant.LOG_UPSTREAM_RESPONSE_CODE, responseObject.getResultCode());
			} else {
				ret.setCode(Constant.FAIL);
			}

		} catch (SocketTimeoutException ste) {
			ErrorUtils.captureException(ste);
			log.info("supplier10000034.vehicleTonnage接口SocketTimeoutException={}", ste);
			ret.setCode(Constant.REQUEST_TIMEOUT);
		} catch (UnrecognizedPropertyException upe) {
			log.info("supplier10000034.vehicleTonnage接口-UnrecognizedPropertyException：{}", upe);
			ErrorUtils.captureException(upe);
			ret.setCode(Constant.SUCCESS);
			ret.setIsCharge(Constant.IS_NOT_CHARGE);
			/** 参数错误 */
			ret.setResultCode(Constant.INVALID_PARAMETER_CODE);

			ResultBody resultBody = new ResultBody();
			resultBody.setCode(3);
			List<String> resultList = new ArrayList<>();
			resultList.add("vehicleNumber");
			resultList.add("licensePlateTypeCode");
			resultList.add("vehicleTonnage");
			resultBody.setResultList(resultList);

			ret.setResultBody(resultBody);

			ret.setResultDesc(Constant.PARAMETER_NAME_ERROR);
			return ret;
		} catch (IOException ioe) {
			log.info("supplier10000034.vehicleTonnage接口-Exception：{}", ioe);
			ErrorUtils.captureException(ioe);
			ret.setCode(Constant.FAIL);
		} catch (Exception ioe) {
			log.info("supplier10000034.vehicleTonnage接口-Exception：{}", ioe);
			ErrorUtils.captureException(ioe);
			ret.setCode(Constant.FAIL);
		}

		return ret;
	}


}