package info.aspirecn.iov.sjjh.supplier10000034.vo;

import java.util.List;

import lombok.Data;
import lombok.ToString;

/**
 * 解析请求JSON串对象
 * @author bzh
 *
 */
@Data
@ToString(callSuper = true, includeFieldNames = true)
public class PersonQualificationResponseObject {
		/**返回码*/
		private String resultCode;	
		/**返回信息*/
		private String resultMsg;	
		/**当前请求服务端标识,用于唯一标识本次请求*/
		private String traceId;	
		/**返回数据*/
		private PersonResponseChildObject data;	
		
		@Data
		public static class PersonResponseChildObject {
			/**data属性-人员姓名*/
			private String nameOfPerson;
			/**data属性-性别*/
			private String gender;
			/**data属性-身份证号码*/
			private String identityDocumentNumber;
			/**省编码*/
			private String provinceCode;
			
			private List<QualificationCertificateInfo> qualificationCertificateInfo;
			
		}
		
		@Data
		public static class QualificationCertificateInfo {
			/**从业资格证号*/
			private String qualificationCertificateNumber;
			/**从业资格类别*/
			private String qualificationCertificateCategoryCode;
			/**certificationUnit*/
			private String certificationUnit;
			/**证件初次发放日期）*/
			private String licenseInitialReleaseDate;
			/**	有效期限开始日期*/
			private String periodStartDate;
			/**有效期限结束日期）*/
			private String periodEndDate;
			/**证照状态*/
			private String certificateState;
		}
		
	}
