package info.aspirecn.iov.sjjh.supplier10000034.vo;

import java.util.List;

import com.fasterxml.jackson.annotation.JsonProperty;

import lombok.Data;
import lombok.ToString;

/**
 * 查询车辆运输许可证信息接口响应对象
 * @author lixinxu
 *
 */
@Data
@ToString(callSuper = true, includeFieldNames = true)
public class VehiclePermitDetailsResponseObject {
	/**返回码*/
	@JsonProperty("resultCode")
	private String resultCode;

	/**返回信息*/
	@JsonProperty("resultMsg")
	private String resultMsg;

	/**链路跟踪编号*/
	@JsonProperty("traceId")
	private String traceId;

	/**返回数据*/
	@JsonProperty("data")
	private Particulars data;

	@Data
	public static class Particulars {
		
		/**车牌号*/
		@JsonProperty("vehicleNumber")
		private String vehicleNumber;

		/**牌照颜色类型代码*/
		@JsonProperty("licensePlateTypeCode")
		private String licensePlateTypeCode;

		/**辆车架号*/
		@JsonProperty("vinNo")
		private String vinNo;

		/**车辆类型*/
		@JsonProperty("vehicleClassification")
		private String vehicleClassification;

		/**车辆车长*/
		@JsonProperty("vehicleLength")
		private String vehicleLength;

		/**车辆车宽*/
		@JsonProperty("vehicleWidth")
		private String vehicleWidth;

		/**车辆车高*/
		@JsonProperty("vehicleHeight")
		private String vehicleHeight;

		/**车辆准牵引总质量*/
		@JsonProperty("vehicleMaximumTractionWeight")
		private String vehicleMaximumTractionWeight;

		/**核定载质量*/
		@JsonProperty("vehicleTonnage")
		private String vehicleTonnage;

		/**车辆营运状态*/
		@JsonProperty("businessState")
		private String businessState;

		/**车辆营运状态代码*/
		@JsonProperty("businessStateCode")
		private String businessStateCode;

		/**道路运输证号*/
		@JsonProperty("roadTransportCertificateNumber")
		private String roadTransportCertificateNumber;

		/**发证单位*/
		@JsonProperty("certificationUnit")
		private String certificationUnit;

		/**有效期起*/
		@JsonProperty("periodStartDate")
		private String periodStartDate;

		/**有效期止*/
		@JsonProperty("periodEndDate")
		private String periodEndDate;

		/**经营范围*/
		@JsonProperty("businessScope")
		private String businessScope;

		/**辆年度审验有效期至*/
		@JsonProperty("checkStateExpireDate")
		private String checkStateExpireDate;

		/**业户名称*/
		@JsonProperty("vehicleCorporationName")
		private String vehicleCorporationName;

		/**发证日期*/
		@JsonProperty("issuingDate")
		private String issuingDate;

	}
}