package info.aspirecn.iov.sjjh.supplier10000034.vo;


import lombok.Data;
import lombok.ToString;

/**
 * 查询车辆道路运输证接口响应对象
 * @author minmin
 *
 */
@Data
@ToString(callSuper = true, includeFieldNames = true)
public class VehicleRoadTransportResponseObject {
	/**返回码*/
	private String resultCode;

	/**返回信息*/
	private String resultMsg;

	/**链路跟踪编号*/
	private String traceId;

	/**返回数据*/
	private VehicleRoadTransportChildObject data;

	@Data
	public static class VehicleRoadTransportChildObject {
		
		/**车牌号*/
		private String vehicleNumber;

		/**牌照颜色类型代码*/
		private String licensePlateTypeCode;

		/**辆车架号*/
		private String vinNo;

		/**车辆长度，单位：mm*/
		private String vehicleLength;

		/**车辆车宽，单位：mm*/
		private String vehicleWidth;

		/**车辆车高，单位：mm*/
		private String vehicleHeight;

		/**车辆准牵引总质量,单位:吨*/
		private String vehicleMaximumTractionWeight;
		
		/**车辆营运状态*/
		private String businessState;
		
		/**车辆类型*/
		private String vehicleClassification;
		
		/**燃料类型*/
		private String fuelType;

		/**核定载质量,单位：吨*/
		private String vehicleTonnage;

		/**道路运输证号*/
		private String roadTransportCertificateNumber;
		
		/**有效期起,YYYYMMDD*/
		private String periodStartDate;

		/**有效期止,YYYYMMDD*/
		private String periodEndDate;
		
		/**发证单位*/
		private String certificationUnit;
		
		/**业户名称*/
		private String vehicleCorporationName;

		/**经营范围*/
		private String businessScope;
		
		/**许可证编号*/
		private String permitNumber;

		/**组织机构代码*/
		private String organizationCode;

		

	}
}